%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function [outputGamma outputnumSeries]= BandgapGetk2xSet(StartGamma,EndGamma,na,n1,n2,t,pitch,N,...
            XLength,deltaX,wavenumber,numSeries,plotsign)
clockStart=clock;
outputnumSeries=numSeries;
sq = inline('x.*x','x');
numB=numSeries*100;

for(ii=153800:5:54200)
   beta(ii)/wavenumber
    BandgapRadiationMode(beta(ii),XLength);
    axis([1995 2000 -2 2]);
    Bandgapeigenequation(Gamma(ii),na,n1,n2,t,pitch,N,...
        XLength,deltaX,wavenumber);
    pause
end;

bii=1;
sectionNum=100;
sizeSection=round(numB/sectionNum);
for Memoryii=1:sectionNum
    Gamma = linspace((EndGamma-StartGamma)/sectionNum*(Memoryii-1)+StartGamma,...
            (EndGamma-StartGamma)/sectionNum*Memoryii+StartGamma,numB/sectionNum)';
    eigenequation = Bandgapeigenequation(Gamma(1:sizeSection),...
        na,n1,n2,t,pitch,N,XLength,deltaX,wavenumber);
    if(Memoryii==1)
        previousone=eigenequation(1);
    end;        
    eigenequation = [previousone; eigenequation;  eigenequation(end)];
    previousone=eigenequation(end);

	plotsign=0;
    if(plotsign==1)
        figure(6); plot(Gamma(1:sizeSection)/wavenumber,eigenequation(2:end-1)); hold on; %axis([min(Gamma),max(Gamma),-10, 10]);
    end;

  
    StartIndex=1;
    ReachMaximumeigenSign=0;

    Totalnumbercalled=0;
    while (bii<numSeries&&ReachMaximumeigenSign==0&&StartIndex<sizeSection+1)
%	while((eigenequation(StartIndex)*eigenequation(StartIndex+1)>0||...
%		abs(eigenequation(StartIndex)-eigenequation(StartIndex+1))>...
%		abs(eigenequation(StartIndex-1)-eigenequation(StartIndex+2)))&&...
%        (ReachMaximumeigenSign==0))

        while((eigenequation(StartIndex)*eigenequation(StartIndex+1)>0)&&...
            (ReachMaximumeigenSign==0))
             StartIndex=StartIndex+1;
            if(StartIndex>sizeSection)   
                 ReachMaximumeigenSign=1; 
            end;
        end
        if (ReachMaximumeigenSign==0)
             StartX=(eigenequation(StartIndex)*Gamma(StartIndex+1-1)...
                -eigenequation(StartIndex+1)*Gamma(StartIndex-1))...
                /(eigenequation(StartIndex)-eigenequation(StartIndex+1));
             
            DirectSign=0;
            if(DirectSign==1)
                StartX0=StartX;
                relTol = 1e-9;	DerX = 1e-8;	changeX=1000;	MaxIterNum=100;IterNum=0;
                 while(abs(changeX/StartX)>relTol&&IterNum<MaxIterNum)
                    StartX;
                    F0=Bandgapeigenequation(StartX,na,n1,n2,t,pitch,N,XLength,deltaX,wavenumber);
                    StartX*(1+DerX);
                    F1=Bandgapeigenequation(StartX*(1+DerX),na,n1,n2,t,pitch,N,XLength,deltaX,wavenumber);
                    changeX = F0/(F0-F1)*(StartX*DerX);
                    StartX=StartX+changeX;
                    IterNum=IterNum+1;
                    Totalnumbercalled=Totalnumbercalled+2;
                   
                end;
                
                if(IterNum>MaxIterNum)	
                    fprintf('exceed max Iternum\n'); 
                end;
            end;
            outputGamma(bii) =StartX;
            bii=bii+1;
            StartIndex=StartIndex+1;
        end;
        
    end;
end;
outputnumSeries=bii-1;
fprintf('finish root finding Bandgapeigenequation call %d times function\n',Totalnumbercalled);

if(plotsign==2)
	figure; plot(1:numSeries,outputGamma); %axis([min(Gamma),max(Gamma),-10, 10]);
end;

outputGamma=outputGamma';
