%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%

function outputbeta = BandgapInfinity(na,n1,n2,t,pitch,wavenumber,PlotSign)

%BandgapInfinity(1,2.89,3.38,1.2e-6,0.2e-6,2*pi/1.15e-6);

lambda = 2*pi/wavenumber;


a=pitch/2;
b=pitch/2;


debugsign =0;

load data/debugsign.dat
save data/lambda.dat lambda  -ascii -tabs;
save data/pitch.dat pitch  -ascii -tabs;
save data/a.dat a  -ascii -tabs;
save data/b.dat b  -ascii -tabs;
save data/n1.dat n1  -ascii -tabs;
save data/n2.dat n2  -ascii -tabs;
save data/na.dat na  -ascii -tabs;
save data/t.dat t  -ascii -tabs;
save data/debugsign.dat debugsign  -ascii -tabs;


neff=n2:-0.00001:0.01;
neffbeta = neff(2:end-1)*wavenumber;
[Eq59 AD] = YehEq59AD(neffbeta);


numneff = length(neffbeta);
numbermodes = 0;

for ii=2:1:numneff-1
 if(Eq59(ii)<Eq59(ii+1)&&Eq59(ii)<Eq59(ii-1)&&...
            Eq59(ii)<1e6&&Eq59(ii)<(Eq59(ii-1)+Eq59(ii+1))/2&&numbermodes<1)
    numbermodes=numbermodes+1;
    [x,fval] =   fminbnd(@YehEq59,neffbeta(ii+2),neffbeta(ii-2),...
        optimset('TolX',1e-20,'Display','iter'));
    if PlotSign==1
        figure;
        Yeh59Mode(x);
    end;
    outputbeta=x;
  end;
end;

