%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function outputbeta = BandgapPlotAD(na,n1,n2,t,pitch)



save data 

betaPitchii=(0.02:0.02:10);omegajj=(0.01:0.01:4);
%betaPitchii=(0.2:0.2:10);omegajj=(0.1:0.1:4);
z=zeros(length(betaPitchii),length(omegajj));
Boundary=ones(length(betaPitchii),13)*7;
for ii=1:length(betaPitchii)
    for jj=1:length(omegajj)
        wavenumber=omegajj(jj)/pitch;
        if betaPitchii(ii)/omegajj(jj) > n2
            z(ii,jj)=2.2;
        else
            z(ii,jj)= YehEq59ADOnly(betaPitchii(ii)/pitch,na,n1,n2,t,pitch,wavenumber);
        end;
    end;
    z(ii,:)=z(ii,:).^2/4;
    z(ii,:)=z(ii,:)-1;

  Startjj=1;
  Boundary(ii,Startjj)=betaPitchii(ii);
  for jj=1:length(omegajj)-1
    if z(ii,jj)*z(ii,jj+1)<0
        Startjj=Startjj+1;
        Boundary(ii,Startjj) = omegajj(jj)+abs(z(ii,jj)/z(ii,jj+1)) ...
            *(omegajj(jj+1)-omegajj(jj))/(1+abs(z(ii,jj)/z(ii,jj+1)));
    end;
  end;
end;

Boundary(1,:)=[Boundary(1,1) 0 Boundary(1,2:end-1)];


z(z>0)=2;z(z<=0)=0;z(z>0)=-1;
z=z.';
x=ones(length(omegajj),1)*betaPitchii;
y=omegajj.'*ones(1,length(betaPitchii));

figure;
[ct,h,cf] = contourf(x,y,z,linspace(-0.1,10,3));
%colorbar;
for k = 1:length(h)
	set(h(k),'linestyle','none');
end
Boundary=Boundary(1:5:end,:);
hold on; plot(Boundary(:,1),[Boundary(:,2:end)],'g');
xlabel('\beta\Lambda');
ylabel('\omega\Lambda/c');

