%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function [CoeffA Ce StartPower neff]=BandgapRadiationMode(CoeffA,Ce,beta,na,n1,n2,t,pitch,N,wavenumber);

numSerCeCoeff=500;


sq=inline('x.*x','x');
% start test
fprintf('run BandgapAnalytical\n');
[M I] = max(Ce);


betaAmp = linspace(beta(I-5), beta(I+5),numSerCeCoeff);
NumSpace=1;


a=pitch/2;
b=pitch/2;
numlayer=N;


Endwithn1sign=0;

if(Endwithn1sign==1)
    gammaAmp=sqrt(sq(wavenumber*n1)-sq(betaAmp));
    gamma=sqrt(sq(wavenumber*n1)-sq(beta));
else
    gammaAmp=sqrt(sq(wavenumber*n2)-sq(betaAmp));
    gamma=sqrt(sq(wavenumber*n2)-sq(beta));
end;

k1x=sqrt(sq(wavenumber*n1)-sq(betaAmp));
k2x=sqrt(sq(wavenumber*n2)-sq(betaAmp));
A=exp(-i*k1x*a).*(cos(k2x*b)-i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
B=exp(i*k1x*a).*(-i/2*(k2x./k1x-k1x./k2x).*sin(k2x*b));
C=exp(-i*k1x*a).*(i/2*(k2x./k1x-k1x./k2x).*sin(k2x*b));
D=exp(i*k1x*a).*(cos(k2x*b)+i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
K=1/pitch*acos(1/2*(A+D));
K = real(K)+i*abs(imag(K));
ka=sqrt(sq(wavenumber*na)-sq(betaAmp));



% start to plot radiation mode

alpha=1;
a0=alpha/2*(cos(ka*t/2)+i*sin(ka*t/2).*ka./k1x);
b0=alpha/2*(cos(ka*t/2)-i*sin(ka*t/2).*ka./k1x);

an=(D.*YehUN(numlayer-1,K,pitch)-YehUN(numlayer-2,K,pitch)).*a0...
        -B.*YehUN(numlayer-1,K,pitch).*b0;
bn=-C.*YehUN(numlayer-1,K,pitch).*a0+(A.*YehUN(numlayer-1,K,pitch)...
        -YehUN(numlayer-2,K,pitch)).*b0;


if(Endwithn1sign==1)

   normlizeCoeff=2*abs(an);
else
        det12 = (1+k2x./k1x).*(1+k2x./k1x)-(1-k2x./k1x).*(1-k2x./k1x);
        cn=2*((1+k2x./k1x).*an-(1-k2x./k1x).*bn)./det12;
        dn=2*(-1*(1-k2x./k1x).*an+(1+k2x./k1x).*bn)./det12;
        normlizeCoeff=2*abs(cn);
end;

 alpha=alpha./normlizeCoeff;
 [M I] = max(alpha);

Ce1P=(cn(I+NumSpace)-cn(I-NumSpace))/(gammaAmp(I+NumSpace)-gammaAmp(I-NumSpace));
Ce10=cn(I)-gammaAmp(I)*Ce1P;



Ce=1./2./abs(Ce10+Ce1P.*gamma); 
x0=(Ce10)/(Ce1P);

if(Endwithn1sign==1)
    neff = sqrt(sq(n1*wavenumber)-sq(conj(-1*x0)))/wavenumber;
else
    neff = sqrt(sq(n2*wavenumber)-sq(conj(-1*x0)))/wavenumber;
end;




CoeffA = max(CoeffA)*Ce/max(Ce);



StartPower = -2*pi*i*max(CoeffA)/max(Ce)/sq(abs(Ce1P))/2/i/imag(x0)/4;


