%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%

function BandgapVaryN(PulseWidth,A,alpha,beta,Startk2x,Endk2x,na,n1,n2,t,pitch,N,numSeries,...
        wavenumber,XLength,deltaX,ShinkXLengthFactor,plotsign)
sq=inline('x.*x','x');
load data/Endwithn1sign.dat;
format long;
LossMatrix = [];
beta0=BandgapInfinity(na,n1,n2,t,pitch,wavenumber,0);

for ii=10:5:40
	Nii=ii;
    if(N==Nii)
        
    else
        N=Nii;
        [k2x numSeries] = BandgapGetk2xSet(Startk2x,Endk2x,na,n1,n2,t,pitch,N,...
            XLength,deltaX,wavenumber,numSeries,plotsign);

        if(Endwithn1sign==1)
            beta= sqrt(sq(n1*wavenumber)-sq(k2x));
        else
            beta= sqrt(sq(n2*wavenumber)-sq(k2x));
        end;
        alpha=zeros(numSeries,1); 
        A=zeros(numSeries,1); 
        for	nii=1:numSeries
            [A(nii) alpha(nii)]=BandgapGetCouplingCoeff(PulseWidth,na,n1,n2,t,pitch,N,...
                XLength,deltaX,wavenumber,beta(nii),ShinkXLengthFactor,plotsign);
        end;
    end;

    [EigenR EigenI]=BandgapLeaky(na,n1,n2,t,pitch,Nii,wavenumber);
    EigenIAppro=BandgapPerturbation(na,n1,n2,...
                t,pitch,Nii,wavenumber,beta0);
    EigenIAppro= imag(EigenIAppro);
    [AAna alphaAna StartPower neff]=BandgapRadiationMode(A,alpha,beta,na,n1,n2,...
                t,pitch,Nii,wavenumber);
	LossMatrix = [LossMatrix; N   EigenI EigenIAppro imag(neff)]
    
end;  
 figure;
 semilogy(LossMatrix(:,1)',LossMatrix(:,2)','b','linewidth',3);
 hold on;
 semilogy(LossMatrix(:,1)',LossMatrix(:,3)','g-.','linewidth',2);
 semilogy(LossMatrix(:,1)',LossMatrix(:,4)','r--','linewidth',2); 
 ylabel('Im(n_{neff})');
 xlabel('Number of periods');