%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%

function ne=ThreeLayerAnalytical(n1,n2,a,wavenumber,plotsign)


r=0;
numPoints=100;
sq=inline('x*x','x');
m=0;
v=wavenumber^2*a^2*(n1^2-n2^2);

b=0:1/numPoints:1;
b=b(1:end-1);
fout=zeros(numPoints,1)';
for ii=1:numPoints	
	fout(ii)=OkamotoEq2_29(b(ii),v);
end
for n=1:numPoints-1
	if(fout(n)*fout(n+1)<0)
		bzero = fzero(@OkamotoEq2_29,b(n),[],v);
	end
end

ne=sqrt(bzero*(sq(n1)-sq(n2))+sq(n2));

if (plotsign==1) 
    beta=ne*wavenumber;
    kapa=sqrt(sq(wavenumber*n1)-sq(beta));
    sigma=sqrt(sq(beta)-sq(wavenumber*n2));
    zeta=sqrt(sq(beta)-sq(wavenumber*n2));
    a=v*sqrt(1-bzero)/kapa;
    x=-a:a/numPoints:a;
    u=v*sqrt(1-bzero);
    w=v*sqrt(bzero);
    wp=v*sqrt(bzero+r);
    phy=m*pi/2+(atan(w/u)-atan(wp/u))/2;
    Ey=cos(kapa*x-phy);
    figure;plot(x/a,Ey);hold on;
    x=-10*a:a/numPoints:-a;
    Ey=cos(kapa*a+phy)*exp(zeta*(x+a));
    plot(x/a,Ey);
    x=a:a/numPoints:10*a;
    Ey=cos(kapa*a-phy)*exp(-sigma*(x-a));
    plot(x/a,Ey); 
end;
