%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%

function ei = ThreeLayerEigenequation(rho,n1,n2,wavenumber,a,XLength)
sq = inline('x*x','x');
sigma = sqrt(rho.*rho+(sq(n1)-sq(n2))*sq(wavenumber));

ei = [tan(rho*(XLength-a)) -tan(sigma*a).*sigma./rho];
ei = [ei(:,1)-ei(:,2) ei];
