%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function Eigen=WTypeEigen(BetaReal,BetaImag,n1,n2,n3,a,b,k0,m);
sq = inline('x*x','x');



neff=(BetaReal+i*BetaImag);
kx=k0*sqrt(n1^2-neff^2);
alpha=k0*sqrt(neff^2-n2^2);



lhs=tan(kx*a);
rhs=(alpha/kx*tanh(atanh(-j*kx/alpha)+alpha*(b-a)));
Eigen=lhs-rhs;


