%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function Matrix0 = WTypeGetAmplitudeAtCenter(A,Ce,beta,n1,numSeries,...
        wavenumber,ZLength,ZNum)
sq=inline('x.*x','x');
Matrix0=zeros(ZNum+1,1);
DeltaZ = ZLength/ZNum;
gamma= sqrt(sq(n1*wavenumber)-beta.*beta);
omegawidth = gamma(2:end) - gamma(1:end-1);
omegawidth = [omegawidth omegawidth(end)];
Vector_Z = linspace(0,ZNum,ZNum+1)*DeltaZ;
  for nii=1:numSeries
    tempnii=A(nii)*Ce(nii)*omegawidth(nii);
    for ii=1:ZNum+1
			Matrix0(ii)=Matrix0(ii)+tempnii*exp(i*beta(nii)*Vector_Z(ii));
    end;
  end;



