%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%

function [Coeff Ce Ae ]= WTypeGetCouplingCoeff(width,n1,n2,a,b,XLength,...
        DeltaX,wavenumber,beta,ShinkXLengthFactor)

sq=inline('xinput*xinput','xinput');

	rho=sqrt(sq(wavenumber*n2)-sq(beta));
	sigma=sqrt(sq(wavenumber*n1)-sq(beta));
    gamma = sigma;
	Ce=1;
	De=Ce/2*exp(i*rho*a)*(cos(sigma*a)-i*sigma/rho*sin(sigma*a));
    Fe=Ce/2*exp(-i*rho*a)*(cos(sigma*a)+i*sigma/rho*sin(sigma*a));
% Fe = conj(De); 
Ae=(1+rho./gamma)/2.*De.*exp(-i*(rho-gamma)*b)...
        +(1-rho./gamma)/2.*Fe.*exp(i*(rho+gamma)*b);

Be=(1+rho./gamma)/2.*Fe.*exp(i*(rho-gamma)*b)...
        +(1-rho./gamma)/2.*De.*exp(-i*(rho+gamma)*b);

    
        
      
  

%	figure(10);
	x1=-a:DeltaX:a;
	Ey1=Ce*cos(sigma*x1);
	x2=a+DeltaX:DeltaX:b;
	Ey2=De*exp(-i*rho*x2)+Fe*exp(i*rho*x2);
	x3=b+DeltaX:DeltaX:XLength/ShinkXLengthFactor;
	Ey3=Ae*exp(-i*gamma*x3)+Be*exp(i*gamma*x3);
    x = [-1*fliplr(x3) -1*fliplr(x2) x1 x2 x3];
	Ey = [fliplr(Ey3) fliplr(Ey2) Ey1 Ey2 Ey3];
	numa= round((XLength/ShinkXLengthFactor-b)/DeltaX);
%	normlizeCoeff = (max(abs(Ey(end-numa+2:end))));
    normlizeCoeff = 2*abs(Ae);
    Ey = Ey/normlizeCoeff;
	fx = exp(-1*x.*x/2/width/width);
%	fx=sech(x/width);
    Coeff = sum(fx.*Ey)/pi*DeltaX;

%    figure(1);plot(1:length(Ey),Ey);    pause;


Ce=Ce/normlizeCoeff;
De = De/  normlizeCoeff;
Fe = Fe/  normlizeCoeff;
Ae=Ae/normlizeCoeff;
Be=Be/normlizeCoeff;



