%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function [value valueAD] = YehEq59AD(neffbeta)

sq=inline('x.*x','x');
load data/lambda.dat ;
load data/pitch.dat ;
load data/a.dat ;
load data/b.dat ;
load data/n1.dat;
load data/n2.dat;
load data/na.dat;
load data/t.dat;
load data/numlayer.dat;
load data/debugsign.dat

wavenumber = 2*pi/lambda;
beta = neffbeta;

Nopq=1;
if (Nopq==1)

k1x=sqrt(sq(wavenumber*n1)-sq(beta));
k2x=sqrt(sq(wavenumber*n2)-sq(beta));
A=exp(-i*k1x*a).*(cos(k2x*b)-i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
B=exp(i*k1x*a).*(-i/2*(k2x./k1x-k1x./k2x).*sin(k2x*b));
C=exp(-i*k1x*a).*(i/2*(k2x./k1x-k1x./k2x).*sin(k2x*b));
D=exp(i*k1x*a).*(cos(k2x*b)+i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
K=1/pitch*acos(1/2*(A+D));
K = real(K)+i*abs(imag(K));
if(debugsign==1)
k1x=sqrt(sq(wavenumber*n1)-sq(beta));
k2x=sqrt(sq(wavenumber*n2)-sq(beta));
A=exp(-i*k1x*a).*(cos(k2x*b)-i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
B=exp(i*k1x*a).*(-i/2*(k2x./k1x-k1x./k2x).*sin(k2x*b));
C=exp(-i*k1x*a).*(i/2*(k2x./k1x-k1x./k2x).*sin(k2x*b));
D=exp(i*k1x*a).*(cos(k2x*b)+i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
K=1/pitch*acos(1/2*(A+D));
K = real(K)+i*abs(imag(K));
beta/wavenumber;
qa=sqrt(sq(beta)-sq(wavenumber*na));
q=-i*k1x;

LHS=kg.*(qa.*cos(kg*t)-kg.*sin(kg*t))./(qa.*sin(kg*t)+kg.*cos(kg*t));
RHS=-i*k1x.*(exp(-i*K*pitch)-A-B)./(exp(-i*K*pitch)-A+B);
value = (abs(LHS-RHS));
end;
qa=sqrt(sq(beta)-sq(wavenumber*na));
ka=sqrt(sq(wavenumber*na)-sq(beta));
q=-i*k1x;
valueAD = A+D;

LHS=-ka.*tan(ka*t/2);
RHS=-i*k1x.*(exp(-i*K*pitch)-A-B)./(exp(-i*K*pitch)-A+B);
value = (abs(LHS-RHS));
%value = 1/2*(A+D);
%`value = abs(A');
%value = abs(D');
%figure,semilogy(neffbeta'/wavenumber,[real(A) real(B) real(C) real(D)]);
%legend('A','B','C','D');
%stop
else

end;