%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%

function valueAD = YehEq59ADOnly(neffbeta,na,n1,n2,t,pitch,wavenumber)

sq=inline('x.*x','x');
a=pitch/2;
b=pitch/2;
beta = neffbeta;

Nopq=1;
if (Nopq==1)
    k1x=sqrt(sq(wavenumber*n1)-sq(beta));
    k2x=sqrt(sq(wavenumber*n2)-sq(beta));
    k1x(k1x==0)=1e-60;
    k2x(k2x==0)=1e-60;
    A=exp(-i*k1x*a).*(cos(k2x*b)-i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
    D=exp(i*k1x*a).*(cos(k2x*b)+i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
    valueAD = A+D;
end;