%
%
%   UndStdLeakyMode
%   Understand leaky modes: Slab waveguide revisited
%
%   Copyright (2008)
%   Computational Photonics Laboratory
%   University of Maryland Baltimore County
%   
%   By Jonathan Hu
%
function value = YehEqLeaky(neffbeta)

sq=inline('x.*x','x');
load data/lambda.dat ;
load data/pitch.dat ;
load data/n1.dat;
load data/n2.dat;
load data/na.dat;
load data/t.dat;
load data/numlayer.dat;

Endwithn1sign=0;
a=pitch/2;
b=pitch/2;



wavenumber = 2*pi/lambda;
beta = neffbeta;

Nopq=1;
if (Nopq==1)

k1x=sqrt(sq(wavenumber*n1)-sq(beta));
k2x=sqrt(sq(wavenumber*n2)-sq(beta));
A=exp(-i*k1x*a).*(cos(k2x*b)-i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
B=exp(i*k1x*a).*(-i/2*(k2x./k1x-k1x./k2x).*sin(k2x*b));
C=exp(-i*k1x*a).*(i/2*(k2x./k1x-k1x./k2x).*sin(k2x*b));
D=exp(i*k1x*a).*(cos(k2x*b)+i/2*(k2x./k1x+k1x./k2x).*sin(k2x*b));
K=1/pitch*acos(1/2*(A+D));
K = real(K)+i*abs(imag(K));


ka=sqrt(sq(wavenumber*na)-sq(beta));



if(Endwithn1sign==1)
    a0= A.*YehUN(numlayer-1,K,pitch)-YehUN(numlayer-2,K,pitch);
    b0= C.*YehUN(numlayer-1,K,pitch);
else
    a0= (A.*YehUN(numlayer-1,K,pitch)-YehUN(numlayer-2,K,pitch)).*(1+k2x./k1x)/2 +B.*YehUN(numlayer-1,K,pitch).*(1-k2x./k1x)/2;
    b0= C.*YehUN(numlayer-1,K,pitch).*(1+k2x./k1x)/2+(D.*YehUN(numlayer-1,K,pitch)-YehUN(numlayer-2,K,pitch)).*(1-k2x./k1x)/2;
end;
LHS=i*ka/k1x.*tan(ka*t/2);
RHS=-1*(b0-a0)./(a0+b0);
value = LHS-RHS;


else

end;